﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SymplexMethod
{
    internal class Symplex
    {
        public decimal[,] EnteringData()
        {
            Console.WriteLine("\nВвод данных:");
            Console.Write("\nВведите количество базисов: ");
            int countBasis = Convert.ToInt32(Console.ReadLine()) + 1;
            Console.Write("\nВведите количество основных переменных: ");
            int countVariables = Convert.ToInt32(Console.ReadLine()) + countBasis;
            decimal[,] symplexArray = new decimal[countBasis, countVariables];
            int count = countVariables - countBasis;
            Console.WriteLine();

            for (int i = 0; i < countBasis; i++)
            {
                if (i < countBasis - 1)
                {
                    for (int i1 = 0; i1 < countVariables - countBasis; i1++)
                    {
                        Console.WriteLine("Введите х{0} для {1} уравнения ограничений", i1 + 1, i + 1);
                        symplexArray[i, i1] = Convert.ToDecimal(Console.ReadLine());
                    }
                }
                else
                {
                    for (int i1 = 0; i1 < countVariables - countBasis; i1++)
                    {
                        Console.WriteLine("Введите коэффициент в целевой функции для х{0}", i1 + 1);
                        symplexArray[i, i1] = (-1) * Convert.ToDecimal(Console.ReadLine());
                    }
                }
                for (int j = countVariables - countBasis; j < countVariables; j++)
                {
                    if (j < countVariables - 1)
                    {
                        for (int i1 = countVariables - countBasis; i1 < countVariables - 1; i1++)
                        {
                            symplexArray[i, i1] = 0;
                            symplexArray[i, count] = 1;
                        }

                    }
                    else if (i == countBasis - 1) symplexArray[i, j] = 0;
                    else
                    {
                        Console.WriteLine("Введите значения L(x) для {0} уравнения ограничений", i + 1);
                        symplexArray[i, j] = Convert.ToDecimal(Console.ReadLine());
                    }
                }
                count++;
            }
            for (int i = 0; i < countBasis; i++)
            {
                for (int j = 0; j < countVariables; j++)
                {
                    Console.Write("[" + i + "," + j + "]: " + Math.Round(symplexArray[i, j], 5) + "\t");
                }
                Console.WriteLine();
            }
            Console.WriteLine();
            return symplexArray;
        }

        public void MaximumTask(decimal[,] symplexArray)
        {
            int count = 0;
            while (count < 1)
            {
                decimal min = symplexArray[0, 0];
                int minj = 0;
                for (int i = symplexArray.GetLength(0) - 1; i < symplexArray.GetLength(0); i++) //Определение ведущего столбца
                {
                    for (int j = 0; j < symplexArray.GetLength(1); j++)
                    {
                        if (min > symplexArray[i, j])
                        {
                            min = symplexArray[i, j];
                            minj = j;
                        }

                    }
                }

                decimal minSb = symplexArray.Length;
                int mini = 0;
                for (int i = 0; i < symplexArray.GetLength(0) - 1; i++)
                {
                    for (int j = symplexArray.GetLength(1) - 1; j < symplexArray.GetLength(1); j++) //Определение ведущей строки
                    {
                        if (symplexArray[i, j] > 0 && symplexArray[i, minj] > 0 && minSb > symplexArray[i, j] / symplexArray[i, minj])
                        {
                            minSb = symplexArray[i, j] / symplexArray[i, minj];
                            mini = i;
                        }
                    }
                }

                decimal helper = symplexArray[mini, minj];
                for (int i = mini; i < mini + 1; i++) //Получение единицы на пересечении ведущей строки и ведущего столбца
                {
                    for (int j = 0; j < symplexArray.GetLength(1); j++)
                    {
                        if (helper != 1)
                        {
                            symplexArray[i, j] = symplexArray[i, j] / helper;
                        }
                    }
                }

                decimal[,] copyArray = (decimal[,])symplexArray.Clone();
                for (int i = 0; i < symplexArray.GetLength(0); i++) 
                {
                    for (int j = 0; j < symplexArray.GetLength(1); j++)
                    {
                        if (i == mini)
                        {
                            continue;
                        }
                        else
                        {
                            copyArray[i, j] = symplexArray[i, j] + ((-1) * symplexArray[i, minj]) * symplexArray[mini, j];
                        }
                    }
                }

                for (int i = 0; i < copyArray.GetLength(0); i++) //Вывод массива
                {
                    for (int j = 0; j < copyArray.GetLength(1); j++)
                    {
                        symplexArray[i, j] = copyArray[i, j];
                        Console.Write("[" + i + "," + j + "]: " + Math.Round(copyArray[i, j], 5) + "\t");
                    }
                    Console.WriteLine();
                }
                Console.WriteLine();

                int countArray = 0;
                for (int i = copyArray.GetLength(0) - 1; i < copyArray.GetLength(0); i++)
                {
                    for (int j = 0; j < copyArray.GetLength(1); j++)
                    {
                        if (copyArray[i, j] < 0)
                        {
                            continue;
                        }
                        else
                        {
                            countArray++;
                            if (countArray == copyArray.GetLength(1)) count++;
                        }
                    }
                }
            }

            Console.WriteLine("Ответ: L(x) = {0}", Math.Round(symplexArray[symplexArray.GetLength(0) - 1, symplexArray.GetLength(1) - 1], 5));
            int newId = 0;
            for (int i = symplexArray.GetLength(0) - 1; i < symplexArray.GetLength(0); i++) //ответ
            {
                for (int j = 0; j < symplexArray.GetLength(1) - 1; j++)
                {
                    if (symplexArray[i, j] != 0)
                    {
                        Console.WriteLine("x{0} = {1}", newId + 1, Math.Round(symplexArray[i, j], 5));
                        newId++;
                    }
                }
            }

        }

        public void MinimumTask(decimal[,] symplexArray)
        {
            int count = 0;
            while (count < 1)
            {
                decimal max = -2000000000;
                int maxj = 0;
                for (int i = symplexArray.GetLength(0) - 1; i < symplexArray.GetLength(0); i++) //Определение ведущего столбца
                {
                    for (int j = 0; j < symplexArray.GetLength(1); j++)
                    {
                        if (max < symplexArray[i, j])
                        {
                            max = symplexArray[i, j];
                            maxj = j;
                        }

                    }
                }

                decimal max_sb = symplexArray.Length;
                int maxi = 0;
                for (int i = 0; i < symplexArray.GetLength(0) - 1; i++)
                {
                    for (int j = symplexArray.GetLength(1) - 1; j < symplexArray.GetLength(1); j++) //Определение ведущей строки
                    {
                        if (symplexArray[i, j] > 0 && symplexArray[i, maxj] > 0 && max_sb > symplexArray[i, j] / symplexArray[i, maxj])
                        {
                            max_sb = symplexArray[i, j] / symplexArray[i, maxj];
                            maxi = i;
                        }
                    }
                }

                decimal helper = symplexArray[maxi, maxj];
                for (int i = maxi; i < maxi + 1; i++) //Получение единицы на пересечении ведущей строки и ведущего столбца
                {
                    for (int j = 0; j < symplexArray.GetLength(1); j++)
                    {
                        if (helper != 1)
                        {
                            symplexArray[i, j] = symplexArray[i, j] / helper;
                        }
                    }
                }

                decimal[,] copyArray = (decimal[,])symplexArray.Clone();
                for (int i = 0; i < symplexArray.GetLength(0); i++) 
                {
                    for (int j = 0; j < symplexArray.GetLength(1); j++)
                    {
                        if (i == maxi)
                        {
                            continue;
                        }
                        else
                        {
                            copyArray[i, j] = symplexArray[i, j] + ((-1) * symplexArray[i, maxj]) * symplexArray[maxi, j];
                        }
                    }
                }

                for (int i = 0; i < copyArray.GetLength(0); i++) //Вывод массива
                {
                    for (int j = 0; j < copyArray.GetLength(1); j++)
                    {
                        symplexArray[i, j] = copyArray[i, j];
                        Console.Write("[" + i + "," + j + "]: " + Math.Round(copyArray[i, j], 5) + "\t");
                    }
                    Console.WriteLine();
                }
                Console.WriteLine();

                int countArray = 0;
                for (int i = copyArray.GetLength(0) - 1; i < copyArray.GetLength(0); i++)
                {
                    for (int j = 0; j < copyArray.GetLength(1); j++)
                    {
                        if (copyArray[i, j] > 0)
                        {
                            continue;
                        }
                        else
                        {
                            countArray++;
                            if (countArray == copyArray.GetLength(1)) count++;
                        }
                    }
                }
            }

            Console.WriteLine("Ответ: L(x) = {0}", Math.Round(symplexArray[symplexArray.GetLength(0) - 1, symplexArray.GetLength(1) - 1], 5));
            int newId = 0;
            for (int i = symplexArray.GetLength(0) - 1; i < symplexArray.GetLength(0); i++) //ответ
            {
                for (int j = 0; j < symplexArray.GetLength(1) - 1; j++)
                {
                    if (symplexArray[i, j] != 0)
                    {
                        Console.WriteLine("x{0} = {1}", newId + 1, Math.Round(symplexArray[i, j], 5));
                        newId++;
                    }
                }
            }
        }

        public void TaskChoise()
        {
            while (true)
            {
                Console.WriteLine("Выберите тип задачи: ");
                Console.WriteLine("1 - на максимум");
                Console.WriteLine("2 - на минимум");
                Console.WriteLine("0 - выход");
                Console.WriteLine();

                int choice = Convert.ToInt32(Console.ReadLine());
                if (choice == 1)
                {
                    MaximumTask(EnteringData());
                }
                else if (choice == 2)
                {
                    MinimumTask(EnteringData());
                }
                else if (choice == 0)
                {
                    break;
                }
                else
                {
                    Console.WriteLine("Введен несуществующий тип задачи!");
                }
            }
        }
    }
}
